package org.jboss.cache.marshall;

import org.jboss.cache.transaction.GlobalTransaction;
import static org.testng.AssertJUnit.assertEquals;
import org.testng.annotations.Test;

/**
 * @author <a href="mailto:manik@jboss.org">Manik Surtani</a>
 */
@Test(groups = {"functional"})
public class MethodCallFactoryTest
{
   public void testVarArgsMethod()
   {
      GlobalTransaction gtx = new GlobalTransaction();
      MethodCall c = MethodCallFactory.create(MethodDeclarations.commitMethod_id, gtx);

      assertEquals(gtx, c.getArgs()[0]);
   }

   public void testObjectArrayMethod()
   {
      GlobalTransaction gtx = new GlobalTransaction();
      MethodCall c = MethodCallFactory.create(MethodDeclarations.commitMethod_id, gtx);

      assertEquals(gtx, c.getArgs()[0]);
   }

   public void testMultipleArrayElems()
   {
      GlobalTransaction gtx = new GlobalTransaction();
      MethodCall c = MethodCallFactory.create(MethodDeclarations.commitMethod_id, gtx, gtx, gtx);

      assertEquals(gtx, c.getArgs()[0]);
      assertEquals(gtx, c.getArgs()[1]);
      assertEquals(gtx, c.getArgs()[2]);

      assertEquals(3, c.getArgs().length);
   }

}
